// mpicc send+recv.c -Wall -o test.x

#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <math.h>

int main( int argc, char *argv[] )
{
   int me, nProcs;
   int data_LOC, data_REC;
   double data;
   MPI_Status status1, status2;
   
   MPI_Init( &argc, &argv );
   MPI_Comm_rank( MPI_COMM_WORLD, &me );
   MPI_Comm_size( MPI_COMM_WORLD, &nProcs );

   srand48( (unsigned) me );
   data_LOC = (int) floor(drand48()*100);
   data_REC = 0;
   data     = 0;
   
   // deadlock? 
   printf(" [%d] sending %d\n", me, data_LOC ); 
   MPI_Send( &data_LOC, 10000, MPI_INT,    (me+nProcs-1)%nProcs, 0, MPI_COMM_WORLD  );
   MPI_Recv( &data,     10000, MPI_INT, (me+1)%nProcs,        0, MPI_COMM_WORLD, &status1 );

   printf( " [%d] received %.15lf\t now sending\n", me, data );   

   MPI_Send( &data,     1, MPI_INT, (me+nProcs-1)%nProcs, 1, MPI_COMM_WORLD  );
   MPI_Recv( &data_REC, 1, MPI_INT,    (me+1)%nProcs,        1, MPI_COMM_WORLD, &status2 ); 
   printf( " [%d] received %.d\n", me, data_REC );  

   MPI_Finalize();
   return 0;
}
